
/**********
FUNCTION TO READ ADC VALUES FROM DIFFERENT ANALOG CHANNELS
0-DC VOLTAGE
1-DC CURRENT
2-AC VOLTAGE
3-AC CURRENT
4-PANEL VOLTAGE
5-PANEL CURRENT
**********/

#include<pic.h>

unsigned int channel[6]={0X45,0X4D,0X55,0X5D,0X65,0X6D};	// VALUES TO SELECT CHANNELS
void delay_us(unsigned int a);
/** FUNCTION TO INITIALISE ADC **/
void adc_init()
{
	TRISA=0XFF;					// SETTING PORT A AS INPUT
	TRISE0=1;					// SETTING PORT E0 BIT AS INPUT
	ADCON1=0X80;				// SETTING CONTROL REGISTER FOR RIGHT JUSTIFIED 10 bit ADC
}
/*****************************************************************************************/

/** FUNCTION TO READ ADC VALUES **/
unsigned int AdcRead(unsigned int channel)
{

	unsigned int temp;			// FOR STORING THE ADC VLAUE
	ADCON0=channel;				// CONTROL REGISETR FOR SELECTING THE ADC CHANNEL
	delay_us(200);			// DELAY FOR CHANNEL CHANGE
	while(ADGO==1);			// WAITING FOR ADC CONVERSION
	temp=((ADRESH<<8)+ADRESL);	// COLLECTING THE READ ADC VALUE
	return temp;
}
/******************************************************************************************/

/** FUNCTION TO CONVRT INT TO STRING **/
char *int_to_string(unsigned int i, unsigned char* buf)
{
	unsigned char temp_var;
	unsigned char s = 0,t = 0;
	if(i!=0)
	{
	while(i)
	{
		buf[s++] = i % 10 + 0x30;
		i/=10;
	}
	buf[s]=0;
	s-=1;
	for(;t<s;t++,s--)
	{
		temp_var = buf[s];
		buf[s]=buf[t];
		buf[t]=temp_var;
	}
	}
	else if(i==0)
	{
		buf[0]='0';
		buf[1]='\0';
	}
	return buf;
}
/*******************************************************************************************/
void delay_us(unsigned int a)
{
 unsigned int f;
 for(f=0;f<=a;f++);
}

