


	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
	/* PROGRAM TO INTERFACE 16X2 LCD WITH PIC16F877 MICROCONTROLLER USING 4-BIT MODE*/
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

//INCLUDE FILES
#include<pic.h>
//LCD CONTROL PINS
#define LcdPinRS RB4
#define LcdPinEN RB5
#define lcdport PORTB		//LCD DATA PINS
#define FourBitmode 0X02	//LCD CONTROL VALUES
#define OneLinDisp 0X20
#define TwoLineDisp 0X28
#define EntryMod 0X06
#define DispOn_CursrOff 0X0C
#define FstLin_FstColumn 0X80
#define ScndLin_FstColumn 0XC0
#define Lcd_clear 0X01
#define ModCmd 0
#define ModData 1

//FUNCTIONS
void Lcd_Init();					// FOR LCD INITIALISATION
void LCD(unsigned char lcddata,unsigned int mode);	// FOR LCD WRITE
void Disp_STRING(const char *d);			// FOR DISPLAY A STRING
unsigned char hinib(unsigned char datain);		// CONVERT THE HIGH NIBBLE OF THE LCD CMD/DATA WORD
unsigned char lonib(unsigned char datain);		// CONVERT THE LOW NIBBLE OF THE LCD CMD/DATA WORD
void delay_Ms(unsigned int a);                          // FOR DELAY
/*FUNCTION TO INITIALISE LCD*/
void Lcd_Init()
{
	TRISB0=0;		// INITIALISE THE PORTD BITS AS OUTPUT PINS
	TRISB1=0;
	TRISB2=0;
	TRISB3=0;
	TRISB4=0;
	TRISB5=0;

	LCD(FourBitmode,ModCmd);		// TO INITIALIZE LCD IN 4-BIT MODE.
	LCD(TwoLineDisp,ModCmd);		// TO INITIALIZE LCD IN 2 LINES, 5X7 DOTS AND 4BIT MODE.
	LCD(EntryMod,ModCmd);			// ENTRY MODE
	LCD(DispOn_CursrOff,ModCmd);				// DISPLAY ON CURSUR OFF
}
/*FUNCTION TO WRITE COMMAND AND DATA TO LCD*/
void LCD(unsigned char lcddata,unsigned int mode)
{
		lcdport=hinib(lcddata);			// RECEIVE LOW NIBBLE OF THE INPUT
		LcdPinRS=mode;					// SET/CLEAR THE REGISTER SELECT BIT
		LcdPinEN=1;						// TOGGLE THE ENABLE BIT
		LcdPinEN=0;

		lcdport=lonib(lcddata);			// RECEIVE HIGH NIBBLE OF THE INPUT
		LcdPinRS=mode;					// SET/CLEAR THE REGISTER SELECT BIT
		LcdPinEN=1;						// TOGGLE THE ENABLE BIT
		LcdPinEN=0;
}
/*FUNCTION TO FIND LOW NIBBLE OF THE LCD INPUT*/
unsigned char lonib(unsigned char datain)
{
	unsigned char low_nib;
	low_nib=(datain&0x0F);		// MASK THE HIGH NIBBLE
	return low_nib;
}
/*FUNCTION TO FIND HIGH NIBBLE OF THE LCD INPUT*/
unsigned char hinib(unsigned char datain)
{
	unsigned char high_nibble;
	high_nibble=((datain>>4)&0x0F);	//  RIGH SHIFT BY 4 BIT AND THEN MASK
	return high_nibble;
}
/*FUNCTION TO DISPLAY A STRING*/
void Disp_STRING(const char *d)
{
	while(*d)
	{
	LCD(*d,ModData);		// DISPLAY EACH CHARECTOR OF THE STRING
	delay_Ms(5);
	d++;
	}
	d=0;
}
void delay_Ms(unsigned int a)
{
    unsigned int i;
    for(i=0;i<=a;i++);
}

