

#include<pic.h>
#include"adc.h"
#include"lcd.h"
__CONFIG(0xFD);
#define _XTAL_FREQ 4000000

// LCD module connections
/*
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections
  */

unsigned char ch0, ch1, ch2, ch3, ch4, ch5, ch6, ch7;
unsigned int adc_rd0, adc_rd1, adc_rd2, adc_rd3;
char text[20], text3[20], text1[20], text2[20];
long et0, et1, et2, et3, kg1, kg2;

void main() {
    INTCON=0x00;

Lcd_Init();                     // LCD display initialization
adc_init();                     // adc module intialization
LCD(DispOn_CursrOff,ModCmd);    // LCD command (cursor off)
LCD(Lcd_clear,ModCmd);          // LCD command (clear LCD)

//text = "Fuel Balance";          // Define the first message
LCD(FstLin_FstColumn,ModCmd);   // Display at position(1,1)
Disp_STRING("Fuel Balance");              // Write the first message in the first line
//text = "System by J.P.";        // Define the second message
LCD(ScndLin_FstColumn,ModCmd);  //Display at (2,1)
Disp_STRING("System by J.P.");              // Define the first message

ADCON1 = 0x82; // A/D voltage reference is VCC
TRISA = 0xFF; // All port A pins are configured as inputs
__delay_ms(1);
LCD(Lcd_clear,ModCmd);

//text1 = "L/H:";
//text2 = "R/H:";
LCD(Lcd_clear,ModCmd);

while (1) {
LCD(FstLin_FstColumn,ModCmd);   // Display at position(1,1)
Disp_STRING("L/H:");
LCD(ScndLin_FstColumn,ModCmd);  //Display at (2,1)
Disp_STRING("R/H:");              // Define the first message
adc_rd0 = AdcRead(channel[0]);
adc_rd1 = AdcRead(channel[1]);
adc_rd2 = AdcRead(channel[2]);
adc_rd3 = AdcRead(channel[3]);
et0 = (long)adc_rd0 * 1000;
et1 = (long)adc_rd1 * 1000;
et2 = (long)adc_rd2 * 1000;
et3 = (long)adc_rd3 * 1000;
et0 = et0 / 1023;
et1 = et1 / 1023;
et2 = et2 / 1023;
et3 = et3 / 1023;
et0 = et1 * 100 / et0;
et2 = et3 * 100 / et2;
kg1 = et0 * 4530 / 100;
kg2 = et2 * 4530 / 100;
ch4 = et0 / 100;
ch5 = et2 / 100;
ch6 = kg1 / 1000;
ch7 = kg2 / 1000;
LCD(FstLin_FstColumn+15,ModCmd);   // Display at position(1,15)
Disp_STRING("KG");
LCD(ScndLin_FstColumn+15,ModCmd);  //Display at (2,15)
Disp_STRING("KG");

LCD(FstLin_FstColumn+11,ModCmd);   // Display at position(1,11)
LCD(48+ch6,ModData);
ch6 = (kg1 / 100) % 10;
LCD(FstLin_FstColumn+12,ModCmd);   // Display at position(1,12)
LCD(48+ch6,ModData);
ch6 = (kg1 / 10) & 10;
LCD(FstLin_FstColumn+13,ModCmd);   // Display at position(1,13)
LCD(48+ch6,ModData);
ch6 = kg1 % 10;
LCD(FstLin_FstColumn+14,ModCmd);   // Display at position(1,14)
LCD(48+ch6,ModData);

LCD(ScndLin_FstColumn+11,ModCmd);  //Display at (2,11)
LCD(48+ch7,ModData);
ch7 = (kg2 / 100) % 10;
LCD(ScndLin_FstColumn+12,ModCmd);  //Display at (2,12)
LCD(48+ch7,ModData);
ch7 = (kg2 / 10) & 10;
LCD(ScndLin_FstColumn+13,ModCmd);  //Display at (2,13)
LCD(48+ch7,ModData);
ch7 = kg2 % 10;
LCD(ScndLin_FstColumn+14,ModCmd);  //Display at (2,14)
LCD(48+ch7,ModData);

if (et0 > 99)
{
LCD(FstLin_FstColumn+6,ModCmd);   // Display at position(1,6)
Disp_STRING("FULL");
}
if (99 > et0 & et0 > 10)
{
LCD(FstLin_FstColumn+6,ModCmd);   // Display at position(1,6)
Disp_STRING(" ");
ch4 = (et0 / 10) % 10;
LCD(FstLin_FstColumn+7,ModCmd);   // Display at position(1,7)
LCD(48+ch4,ModData);
ch4 = et0 % 10;
LCD(FstLin_FstColumn+8,ModCmd);   // Display at position(1,8)
LCD(48+ch4,ModData);
LCD(FstLin_FstColumn+9,ModCmd);   // Display at position(1,9)
LCD('%',ModData);
}
if (et0 < 10)
{
LCD(FstLin_FstColumn+6,ModCmd);   // Display at position(1,6)
Disp_STRING("LOW!");
}
if (et2 > 99)
{
LCD(ScndLin_FstColumn+6,ModCmd);  //Display at (2,6)
Disp_STRING("FULL");
}
if (99 > et2 & et2 > 10)
{
LCD(ScndLin_FstColumn+6,ModCmd);  //Display at (2,6)
Disp_STRING(" ");
ch5 = (et2 / 10) % 10;
LCD(ScndLin_FstColumn+7,ModCmd);  //Display at (2,7)
LCD(48+ch5,ModData);
ch5 = et2 % 10;
LCD(ScndLin_FstColumn+8,ModCmd);  //Display at (2,8)
LCD(48+ch5,ModData);
LCD(ScndLin_FstColumn+9,ModCmd);  //Display at (2,9)
LCD('%',ModData);
}
if (et2 < 10)
{
LCD(ScndLin_FstColumn+6,ModCmd);  //Display at (2,6)
Disp_STRING("LOW!");
}

/*Lcd_Chr(1,11,48+ch0);
Lcd_Chr_CP('.');
ch0 = (tlong0 / 100) % 10;
Lcd_Chr_CP(48+ch0);
ch0 = (tlong0 / 10) % 10;
Lcd_Chr_CP(48+ch0);
ch0 = tlong0 % 10;
Lcd_Chr_CP(48+ch0);
Lcd_Chr_CP('V'); */
__delay_ms(1);
}
}


